<?php

/**
 * co_solicitud_modificacion actions.
 *
 * @package    contratacion
 * @subpackage co_solicitud_modificacion
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
require_once 'HTMLPurifier.auto.php';
require 'HTMLPurifier.autoload.php';

class co_solicitud_modificacionActions extends sfQuery {
    /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    protected $table_names = array(
        'CO_SOLICITUD_MODIFICACION', 'CO_CONTRATO_V'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
        'CO_CONTRATO_V' =>
        array(
            'id_contrato' => 'CO_SOLICITUD_MODIFICACION'
        )
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'CO_SOLICITUD_MODIFICACION' =>
        array(
            'id_solicitud_modificacion' => 'id_solicitud_modificacion',
            'id_contrato' => 'id_contrato',
            'no_solicitud' => 'no_solicitud',
            'fecha_solicitud' => 'fecha_solicitud',
            'no_modificacion' => 'no_modificacion',
            'justificacion' => 'justificacion'
        ),
        'CO_CONTRATO_V' =>
        array(
            'no_contrato' => 'no_contrato',
            'id_anhos' => 'id_anhos',
            'proceso' => 'proceso',
            'valor' => 'valor_contrato',
            'completo_contra' => 'completo_contra',
            'completo_supervisor' => 'completo_supervisor'
        )
    ); //por cada tabla especificar los campos del select
    protected $fields_orderBy = array(
    ); //campos para el ordenamiento de la consulta
    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
        'CO_SOLICITUD_MODIFICACION' =>
        array(
            'id_solicitud_modificacion,a' => array('!=' => array(-1)),
            'id_solicitud_modificacion,b' => array('=' => array('id_solicitud_modificacion')),
            'id_contrato,b' => array('=' => array('id_contrato')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        ),
        'CO_CONTRATO_V' =>
        array(
            'no_contrato' => array('=' => array('no_contrato')),
            'id_tipo_contrato' => array('=' => array('id_tipo_contrato')),
            'id_tipo_convenio' => array('=' => array('id_tipo_convenio')),
            'id_contratista' => array('=' => array('id_contratista'))
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(
    ); // filtros de condicion or
    /*
     * Variable manejo de log
     */
    //true - consulta de menu administracion
    protected $is_admin = true;
    //si es servicio para filtro agregar campo
//    protected $filtro = 'Perfiles';
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;
    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = 'id_solicitud_modificacion'; //identificador de la tabla
    protected $id_names = array('id_solicitud_modificacion'); //llave primaria
    protected $field_names = array('id_contrato', 'no_solicitud', 'fecha_solicitud', 'justificacion', 'no_modificacion'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'CO_SOLICITUD_MODIFICACION'; //tabla en la cual se aplican los cambios 
    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id_solicitud_modificacion'; //identificador unico de la tabla

    protected function postprocessRequest($Action, \sfWebRequest $request, $list_data_post) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);
        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
            $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
            $this->conn->beginTransaction();
            try {

                //ENVIO CORREO 9 - Notificacion de Solicitud de Cesión
//PARAMETROS GENERALES

                $subject = "Notificacion de Solicitud de Modificacion";
//Email Envio
                if (!isset($request["email_envio"])) {
                    $request["email_envio"] = "modulocontratacion@sgc.gov.co";
                }
                $adjunto = false;
                $ruta = "";

                /*
                 * Variable Memcache
                 */
                $progress_key = $request['progress_key'] . $request['username'];
                $this->logMessage("Valor de progress_key: " . $progress_key);

                $array_adjuntos = array();


                $sql = "
        SELECT tab0.dia_sistema||' de '||tab0.mes_sistema||' del '||anho_sistema AS FECHA_SISTEMA
           from(
            select LPAD(to_char(sysdate,'dd'),2,'0') as dia_sistema,
            trim(initcap(to_char(sysdate,'MONTH','nls_date_language=spanish'))) as mes_sistema,
            TO_CHAR(sysdate,'yyyy') as anho_sistema
            from dual
        )tab0
        ";

                $records = CN_TABLE::executeSQL($sql);
                $fecha_creacion = $records[0]['fecha_sistema'];



                $id_contrato = $list_data_post[0]['id_contrato'];
                $id_solicitud_modificacion = $list_data_post[0]['id_solicitud_modificacion'];

                $sql = <<<EOD
select tab0.no_modificacion
    
from(                     
                     
select tab0.no_modificacion

from co_solicitud_modificacion tab0
join co_contrato tab2 ON tab2.id_contrato = tab0.id_contrato
where tab0.id_solicitud_modificacion = $id_solicitud_modificacion
                     
)tab0                     
                     
EOD;

                $records = CN_TABLE::executeSQL($sql);

                $no_modificacion = $records[0]['no_modificacion'];
                



                $sql = <<<EOD
select tab0.no_contrato, tab0.valor, tab0.objeto, tab0.tipo, tab0.completo_contra, tab0.completo_supervisor, tab1.id_estudios_previos

from co_contrato_v tab0
join co_seleccion_ep tab1 ON tab1.id_seleccion_ep = tab0.id_seleccion_ep
where tab0.id_contrato = $id_contrato
EOD;

                $records = CN_TABLE::executeSQL($sql);

                $no_contrato = $records[0]['no_contrato'];
                $tipo = $records[0]['tipo'];
                $contratista = $records[0]['completo_contra'];
                $supervisor = $records[0]['completo_supervisor'];
                $objeto = $records[0]['objeto'];
                $id_estudios_previos = $records[0]['id_estudios_previos'];

                $sql = <<<EOD
select tab0.* from co_estudios_previos_v tab0 where tab0.id_estudios_previos = $id_estudios_previos
EOD;

                $records = CN_TABLE::executeSQL($sql);

                $responsable = $records[0]['nombre_responsable'];
                $area = $records[0]['area'];
                $valor = $records[0]['valor'];
                $valor = number_format($valor);
                $modalidad = $records[0]['modalidad'];
                $abogado = $records[0]['abogado'];
                $proceso = $records[0]['proceso'];





//1. Se realiza Consulta a la tabla de administracion alarmas para saber a quien van dirigidos los correos

                $sql = <<<EOD
select tab2.num_doc, tab2.id_tipo_doc, tab2.razon_soc, nvl(tab3.mail,'modulocontratacion@sgc.gov.co') email, tab4.descripcion as rol
from co_administra_alarma tab0
join co_rol_proceso_v tab1 ON tab1.id_rol = tab0.id_rol and tab1.id_estudios_previos = $id_estudios_previos
join interceros_v tab2 ON tab2.id_mae_ter = tab1.id_mae_ter
join interceros_du_dir_v tab3 ON tab3.id_mae_ter = tab2.id_mae_ter
join co_rol tab4 ON tab4.id_rol = tab0.id_rol                        
where tab0.id_alarma = 9 and tab1.id_mae_ter is not null
EOD;

                $records = CN_TABLE::executeSQL($sql);

                foreach ($records as $correos) {

                    $documento = $correos['num_doc'];
                    $tipo_doc = $correos['id_tipo_doc'];
                    $nombre = $correos['razon_soc'];
                    $email = $correos['email'];
                    $rol = $correos['rol'];

                    $parametros = $documento . ";$tipo_doc;" . $email . ";" . $nombre . ";Envio notificacion";

                    $datos_usuario = array();

                    if ($parametros != "") {
                        $datos_usuario = explode('/', $parametros);
                    }

//CUERPO DEL MENSAJE

                    $body = "<html><body> </body></html>";
//Body
                    $body = <<<EOD
                <html><body> 
                <br/>
                Bogotá, $fecha_creacion
                <br/>
                <br/>
                Señor(a)<br/>
                $nombre<br/>
                $rol
                <br/><br/>
                Por medio de la presente se notifica la <b>Solicitud de Modificacion</b> del Contrato No. $no_contrato</b><br/><br/>
                <b>DATOS DE LA SOLICITUD:</b><br/>
                <b>No Modificación</b> $no_modificacion<br/>
                <b>DATOS DEL CONTRATO:</b><br/>
                <b>Contratista.</b> $contratista<br/>
                <b>Supervisor:</b> $supervisor<br/>
                <b>Tipo de Contrato:</b> $tipo<br/>
                <b>Valor del Contrato:</b> $valor<br/>
                <b>Objeto:</b> $objeto<br/>
                <br></br>
                <b>DATOS DEL PROCESO</b>
                <br></br>
                <b>Proceso No.</b> $proceso<br/>
                <b>Area:</b> $area<br/><br/>
                <b>Responsable:</b> $responsable<br/>
                <b>Abogado:</b> $abogado<br/>
                <br/><br/>
                
                </body></html>
EOD;

                    $currentUri = "";

                    CN_TABLE::envioCorreo($request, $datos_usuario, $subject, $currentUri, $ruta, $adjunto, $progress_key, $array_adjuntos, $body);
                }
            } catch (Exception $e) {

                //ROLLBACK DE TODAS LAS TRANSACCIONES EN CASO DE QUE OCURRA ALGUN ERROR
                $this->conn->rollback();
            }
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function preprocessRequest($Action, \sfWebRequest $request) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        $config = HTMLPurifier_Config::createDefault();
        $purifier = new HTMLPurifier($config);

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {

            $justificacion = $request['justificacion'];
            $justificacion_limpio = $purifier->purify($justificacion);

            $request['justificacion'] = $justificacion_limpio;

            $sql = <<<EOD
select to_char(sysdate,'YYYY') as ID_ANHOS FROM DUAL
EOD;

            $records = CN_TABLE::executeSQL($sql);

            $id_anhos = $records[0]['id_anhos'];

            $sql = <<<EOD
select consecutivo from co_consecutivo_solicitud where id_anhos = $id_anhos
EOD;
            $records = CN_TABLE::executeSQL($sql);

            $consecutivo = $records[0]['consecutivo'];

            $request['no_solicitud'] = $consecutivo;

            $sql = <<<EOD
update co_consecutivo_solicitud set consecutivo =($consecutivo+1) where id_anhos = $id_anhos
EOD;

            CN_TABLE::executeSQL($sql);
        }

        //accion update
        if ($Action == "UPDATE") {
            $justificacion = $request['justificacion'];
            $justificacion_limpio = $purifier->purify($justificacion);

            $request['justificacion'] = $justificacion_limpio;
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function validateAdd(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateRemove(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateUpdate(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

}
